/*
 * Copyright 2006 Werner Guttmann
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.castor.jdo;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Run all tests of the org.castor.jdo package.
 * 
 * @author <a href="mailto:werner DOT guttmann AT gmx DOT net">Werner Guttmann</a>
 * @version $Revision: 5951 $ $Date: 2006-04-29 11:57:35 +0200 (Sa, 29 Apr 2006) $
 * @since 1.0
 */
public final class TestAll extends TestCase {
    
    public static Test suite() throws Exception {
        TestSuite suite = new TestSuite("All org.castor.jdo tests");

        suite.addTest(org.castor.jdo.drivers.TestAll.suite());
        suite.addTest(org.castor.jdo.engine.TestAll.suite());

        return suite;
    }

    public TestAll(final String name) { 
        super(name); 
    }
}
